// import fs from "fs";
// import { fileURLToPath } from "url";
// import { dirname } from "path";
// import path from "path";
// import Element from "./beautify/element.js";
// import logger from "../../logger.js";
// import { AccessibilityDump } from "./accessibility_dump.js";

// const __filename = fileURLToPath(import.meta.url);
// const __dirname = dirname(__filename);

// class DumpPage {
//   constructor() {
//     this.type = "dump_page";
//   }

//   async execute(context) {
//     //console.log("dump page");

//     context.page.on("console", (msg) => {
//       for (let i = 0; i < msg.args.length; ++i)
//         console.log(`${i}: ${msg.args[i]}`);
//     });
//     const dompath = fs.readFileSync(
//       path.resolve(__dirname, "./browser_side/dompath_new.js"),
//       "utf8"
//     );
//     const locatorBuffer = fs.readFileSync(
//       path.resolve(__dirname, "./browser_side/find_locator.js"),
//       "utf8"
//     );
//     const buffer = fs.readFileSync(
//       path.resolve(__dirname, "./browser_side/page_analyze.js"),
//       "utf8"
//     );
//     const script =
//       dompath.toString() +
//       "\n" +
//       locatorBuffer.toString() +
//       "\n" +
//       buffer.toString();
//     let result = null;
//     for (let i = 0; i < 3; i++) {
//       try {
//         result = await context.page.evaluate(script);
//         break;
//       } catch (err) {
//         logger.error("Failed to dump page: " + err);
//         if (i == 2) {
//           throw err;
//         }
//         await new Promise((resolve) => setTimeout(resolve, 2000));
//       }
//     }
//     // convert to json
//     let resultObject = JSON.parse(result);
//     context.previousUrl = context.url;
//     context.dump = new PageDump(
//       resultObject.elements,
//       resultObject.title,
//       resultObject.url,
//       resultObject.rows
//     );
//     context.url = resultObject.url;

//     try {
//       var s = resultObject.title;
//       if (!s) {
//         // generate random string
//         s = Math.random().toString(36).substring(7);
//       }
//       let filename = s.replaceAll(/[^a-z0-9]/gi, "_").toLowerCase() + ".json";
//       if (!fs.existsSync("./pages")) {
//         fs.mkdir("./pages", { recursive: true });
//       }
//       fs.writeFileSync("./pages/" + filename, result, "utf-8");
//     } catch (err) {
//       console.error(err);
//     }
//     const assessibilityDumpt = new AccessibilityDump();
//     await assessibilityDumpt.execute(context);
//     //console.log(`Found ${context.dump.length} elements`);
//   }
// }

// class PageDump {
//   constructor(elements, title, url, rows, _elements = null) {
//     this.elements = elements;
//     this.title = title;
//     this.url = url;
//     this.rows = rows;
//     this._elements = [];
//     for (let i = 0; i < elements.length; i++) {
//       let el = new Element();
//       el.fromJson(elements[i]);
//       this._elements.push(el);
//     }
//     if (this.rows) {
//       for (let i = 0; i < this.rows.length; i++) {
//         let el = new Element();
//         el.fromJson(this.rows[i].row);
//         el.rowData = this.rows[i].rowData;
//         if (this.rows[i].elements) {
//           for (let j = 0; j < this.rows[i].elements.length; j++) {
//             let el2 = new Element();
//             el2.fromJson(this.rows[i].elements[j]);
//             el.rowActionElements.push(el2);
//           }
//         }
//         this._elements.push(el);
//       }
//     }
//   }
// }
// export { DumpPage, PageDump };
