// ai failure identifier

// eslint-disable-next-line
const isRecordingFailed = (taskProgress) => {
  if (!taskProgress || taskProgress.shadow) {
    return false;
  }
  if (taskProgress.commands.length > 15) {
    return true;
  }
  if (taskProgress.commands && taskProgress.commands.length > 2) {
    // check if the last command memory repeat itself 3 times
    const lastCommandIndex = taskProgress.commands.length - 1;
    const memory = taskProgress.commands[lastCommandIndex];
    let count = 0;
    for (let i = lastCommandIndex - 2; i >= 0; i--) {
      const command = taskProgress.commands[i];
      if (command.memory === memory) {
        count++;
        if (count === 3) {
          return true;
        }
      }
    }
  }

  return false;
};
// eslint-disable-next-line
const generateRecoveryTasks = (taskProgress) => {};

export { isRecordingFailed, generateRecoveryTasks };
