// import { Command, Types, Statuses, postCommandSleep } from "./command.js";
// import { CommandResult } from "./command.js";
// import logger from "../../logger.js";
// import { AccessibilityDump } from "../tasks/accessibility_dump.js";

// class CheckElement extends Command {
//   constructor(id, checked, recording) {
//     super(
//       Types.CLICK,
//       "check/uncheck on element in the page, applicable for checkbox and radio buttons",
//       [
//         { name: "id", description: "element id number" },
//         { name: "checked", description: "true for check false for uncheck" },
//       ],
//       recording
//     );
//     this.id = id;
//   }
//   async run(context, executeStep = null) {
//     this.preRun(context);
//     let element = null;
//     if (executeStep) {
//       element = executeStep.element;
//     } else {
//       for (let i = 0; i < context.elements.length; i++) {
//         if (context.elements[i].localId === this.id) {
//           element = context.elements[i];
//         }
//       }
//       this.recordingStep.element = element;
//     }

//     if (!element) {
//       logger.error(`Element with id ${this.id} not found`);
//       throw new Error(`Element with id ${this.id} not found`);
//     }
//     // retry to click on the element
//     let maxTry = 3;
//     for (let i = 0; i < maxTry; i++) {
//       logger.info(`Check element: ${element.getReadableType()}: ${element.getText()} status: ${this.checked}`);
//       try {
//         await context.stable.setChecked(element.getUniqueLocatorObject(), this.checked);
//       } catch (err) {
//         logger.error(`Failed to click on element: ${err}`);
//         await new Promise((resolve) => setTimeout(resolve, 1000));
//         if (i === maxTry - 1) {
//           throw err;
//         }
//       }
//     }

//     //context.page.click(this.line);
//     context.stable.waitForPageLoad();
//     await new Promise((resolve) => setTimeout(resolve, postCommandSleep + 1500));

//     // const tast2 = new DumpPage();
//     // await tast2.execute(context);
//     // const task3 = new PageBeautify2();
//     // await task3.execute(context);

//     const task2 = new AccessibilityDump();
//     await task2.execute(context);

//     const result = new CommandResult();

//     result.longTermMemory = `clicked on element: ${element.getReadableType()}: ${element.getText()}`;
//     result.lastCommandResult = context.interactionElementsText;
//     result.pageText = context.pageText;
//     this.recordingStep.status = Statuses.PASSED;
//     return result;
//   }
// }
// export { CheckElement };
