// //function page_analyze() {
// const result = [];

// forms = new Map();
// function isBackgrounElement(element) {
//   let rec = element.getBoundingClientRect();
//   let xCenter = rec.left + rec.width / 2;
//   let yCenter = rec.top + rec.height / 2;
//   let elementAtPoint = document.elementFromPoint(xCenter, yCenter);
//   if (!elementAtPoint) {
//     return false;
//   }
//   if (elementAtPoint.contains(element)) {
//     return false;
//   }
//   // check if the element is the same element or same as parent
//   let toCheck = elementAtPoint;
//   while (toCheck) {
//     if (toCheck === element) {
//       return false;
//     }
//     toCheck = toCheck.parentElement;
//   }

//   return true;
// }
// function isVisible(elem) {
//   if (!(elem instanceof Element)) {
//     return false;
//   }
//   const style = getComputedStyle(elem);
//   if (style.display === "none") return false;
//   if (style.visibility !== "visible") return false;
//   if (style.opacity < 0.1) return false;
//   if (
//     elem.offsetWidth +
//       elem.offsetHeight +
//       elem.getBoundingClientRect().height +
//       elem.getBoundingClientRect().width ===
//     0
//   ) {
//     return false;
//   }
//   return true;
// }
// isOnScreen = (elem) => {
//   const elemCenter = {
//     x: elem.getBoundingClientRect().left + elem.offsetWidth / 2,
//     y: elem.getBoundingClientRect().top + elem.offsetHeight / 2,
//   };
//   if (elemCenter.x < 0) return false;
//   if (
//     elemCenter.x > (document.documentElement.clientWidth || window.innerWidth)
//   )
//     return false;
//   if (elemCenter.y < 0) return false;
//   if (
//     elemCenter.y > (document.documentElement.clientHeight || window.innerHeight)
//   ) {
//     return false;
//   }
//   return true;
// };
// // find the nearest parent with innerText
// parentInnerText = (element) => {
//   let parent = element;
//   while (parent) {
//     if (parent.innerText) {
//       return parent.innerText;
//     }
//     parent = parent.parentElement;
//   }
//   return "";
// };

// readElementInfo = (element, formIndex) => {
//   //console.log("readElementInfo", element);
//   const attr = element.getAttributeNames();
//   const attrMap = {};
//   attr.forEach((a) => {
//     attrMap[a] = element.getAttribute(a);
//   });
//   const rect = element.getBoundingClientRect();
//   let formUniqueId = formIndex;
//   if (element.form) {
//     //console.log("forms was identify");
//     if (!forms.has(element.form)) {
//       forms.set(element.form, forms.size);
//     }
//     formUniqueId = forms.get(element.form);
//     //console.log("formUniqueId", formUniqueId);
//   }
//   let options = [];
//   if (
//     element.tagName.toLowerCase() === "select" ||
//     element.attributes["role"] === "select"
//   ) {
//     options = readOptions(element);
//   }
//   // collect parents sizes
//   let parentsSizes = [];
//   let parent = element;
//   while (parent) {
//     const rect = parent.getBoundingClientRect();
//     parentsSizes.push({
//       width: rect.width,
//       height: rect.height,
//       top: rect.top,
//       left: rect.left,
//     });
//     parent = parent.parentElement;
//   }
//   let label = null;
//   if (element.hasAttribute("id")) {
//     label = findLabelText(element.id);
//   }

//   return {
//     tagName: element.tagName.toLowerCase(),
//     attributes: attrMap,
//     location: {
//       top: rect.top,
//       left: rect.left,
//       width: rect.width,
//       height: rect.height,
//     },
//     innerText: element.innerText,
//     textContent: element.textContent,
//     // clickable: getEventListeners(element).hasOwnProperty("click"),
//     // inputable: getEventListeners(element).hasOwnProperty("input"),
//     formUniqueId: formUniqueId,
//     locator: getUniqueLocator(element, document),
//     disabled: element.disabled,
//     visible: isVisible(element),
//     onScreen: isOnScreen(element),
//     background: isBackgrounElement(element),
//     parentInnerText: parentInnerText(element),
//     parentsSizes: parentsSizes,
//     value: element.value,
//     options: options,
//     label: label,
//   };
// };
// const cssElements = [
//   "a[href]",
//   "button",
//   "input",
//   "textarea",
//   "select",
//   "[role='select']",
//   "img[alt]",
//   "[role='button']",
//   "[role='checkbox']",
// ];
// function collectAllElementsUnder(node, objects) {
//   cssElements.forEach((css) => {
//     node.querySelectorAll(css).forEach((a) => {
//       objects.add(a);
//     });
//   });
// }
// function readOptions(select) {
//   const options = [];
//   select.querySelectorAll("option").forEach((option) => {
//     options.push({
//       value: option.value,
//       text: option.text,
//       selected: option.selected,
//     });
//   });
//   return options;
// }
// function findDirectTextNodes(node, objects) {
//   const childNodes = node.childNodes;
//   for (let i = 0; i < childNodes.length; i++) {
//     const childNode = childNodes[i];
//     if (
//       childNode.nodeType === Node.TEXT_NODE &&
//       childNode.textContent.trim() !== "" &&
//       isNodeVisible(childNode.parentElement)
//     ) {
//       objects.add(node);
//     } else if (
//       childNode.nodeType === Node.ELEMENT_NODE &&
//       childNode.tagName !== "SCRIPT" &&
//       isNodeVisible(childNode)
//     ) {
//       findDirectTextNodes(childNode, objects);
//     }
//   }
// }

// function isNodeVisible(node) {
//   const style = window.getComputedStyle(node);
//   return style.display !== "none" && style.visibility !== "hidden";
// }
// function isParentRow(node) {
//   let parent = node.parentElement;
//   while (parent) {
//     if (
//       parent.tagName.toLowerCase() === "tr" ||
//       parent.getAttribute("role") === "row"
//     ) {
//       return true;
//     }
//     parent = parent.parentElement;
//   }
//   return false;
// }
// function getTextFromElement(element) {
//   let text = "";

//   function traverse(element) {
//     // If the current element is a text node, append its content to the result
//     if (element.nodeType === Node.TEXT_NODE) {
//       text += element.textContent.trim();
//     }

//     // Recursively traverse the child nodes
//     for (let i = 0; i < element.childNodes.length; i++) {
//       traverse(element.childNodes[i]);
//     }
//   }

//   // Start traversing from the input element
//   traverse(element);

//   return text;
// }
// const processRow = (row, rowsData) => {
//   if (!isVisible(row) || isBackgrounElement(row)) {
//     return;
//   }
//   const rowData = [];
//   const cells = row.querySelectorAll(
//     "td, th, [role='cell'], [role='columnheader']"
//   );
//   cells.forEach((cell) => {
//     if (!isVisible(cell) || isBackgrounElement(cell)) {
//       return;
//     }
//     const text = getTextFromElement(cell);
//     rowData.push(text);
//   });
//   rowsData.push({ row, rowData });
// };

// function processPageRows() {
//   const rowsData = [];
//   const rows = document.querySelectorAll("tr, [role='row']");
//   rows.forEach((row) => {
//     processRow(row, rowsData);
//   });
//   return rowsData;
// }
// function findLabelText(id) {
//   const labels = document.querySelectorAll(`label[for='${id}']`);
//   if (labels.length > 0) {
//     return labels[0].innerText;
//   }
//   return null;
// }

// const objects = new Set();
// collectAllElementsUnder(document, objects);
// findDirectTextNodes(document, objects);

// objects.forEach((o) => {
//   if (!isParentRow(o)) {
//     result.push(readElementInfo(o, -1));
//   }
// });
// for (const entry of forms.entries()) {
//   result.push(readElementInfo(entry[0], entry[1]));
// }

// const rowsData = processPageRows();
// rowsData.forEach((row) => {
//   let objects = new Set();
//   collectAllElementsUnder(row.row, objects);
//   let elements = [];
//   objects.forEach((o) => {
//     if (isVisible(o) && !isBackgrounElement(o)) {
//       elements.push(readElementInfo(o, -1));
//     }
//   });
//   row.elements = elements;
//   row.row = readElementInfo(row.row, -1);
// });

// let returnObj = {
//   title: document.title,
//   url: window.location.href,
//   elements: result,
//   rows: rowsData,
// };
// JSON.stringify(returnObj);
